From 0cd745d451109522891194b954982710c6bd736d Mon Sep 17 00:00:00 2001
From: Cerrato Renaud <r.cerrato@til-technologies.fr>
Date: Thu, 7 Mar 2013 09:02:55 +0100
Subject: [PATCH 4/4] corrected initial vbus detection

---
 drivers/usb/gadget/at91_udc.c |   10 ++++++++--
 1 files changed, 8 insertions(+), 2 deletions(-)

diff --git a/drivers/usb/gadget/at91_udc.c b/drivers/usb/gadget/at91_udc.c
index 3899db2..0654038 100644
--- a/drivers/usb/gadget/at91_udc.c
+++ b/drivers/usb/gadget/at91_udc.c
@@ -1327,6 +1327,12 @@ static void at91_update_vbus(struct at91_udc *udc, u32 value)
 		dev_set_param(udc->dev, "vbus", "0");
 
 	udc->gpio_vbus_val = value;
+	udc->vbus = value != 0;
+
+	if(udc->driver)
+		pullup(udc, udc->vbus);
+	else
+		pullup(udc, 0);
 }
 
 int usb_gadget_poll(void)
@@ -1508,7 +1514,7 @@ static int __init at91udc_probe(struct device_d *dev)
 		 * Get the initial state of VBUS - we cannot expect
 		 * a pending interrupt.
 		 */
-		udc->vbus = gpio_get_value(udc->board.vbus_pin);
+		udc->vbus = gpio_get_value(udc->board.vbus_pin) ^ udc->board.vbus_active_low;
 		DBG(udc, "VBUS detection: host:%s \n",
 			udc->vbus ? "present":"absent");
 	} else {
@@ -1517,7 +1523,7 @@ static int __init at91udc_probe(struct device_d *dev)
 	}
 
 	dev_add_param(dev, "vbus", NULL, NULL, 0);
-	dev_set_param(dev, "vbus", "0");
+	dev_set_param(dev, "vbus", udc->vbus ? "1" : "0");
 
 	poller_register(&poller);
 
-- 
1.7.2.5

